; GUI #
include win64a.inc
IDC_EDIT    equ 100
IDD_DLG1    equ	101
IDC_ICON1   equ 10
MARGIN_X    equ 30
.code
WinMain proc
local	dummy:qword

	mov	ecx,offset LibFileName
        invoke	LoadLibrary
	invoke	LoadIcon,IMAGE_BASE,IDC_ICON1
	mov	hIcon,rax
	mov	r9d,offset DlgProc
	invoke	DialogBoxParam,IMAGE_BASE,IDD_DLG1,0,,rax
    	invoke	RtlExitUserProcess,NULL
WinMain endp

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov	hWnd,rcx

        cmp	edx, WM_INITDIALOG
	jz	wmINITDIALOG
        cmp	edx, WM_CLOSE
	jz	wmCLOSE
wmdefault:xor	eax, eax
	jmp	wmBYE
wmINITDIALOG:
	invoke	SendMessage,,WM_SETICON,0,hIcon
	invoke	SendDlgItemMessage,hWnd,IDC_EDIT,EM_SETMARGINS,\
	EC_LEFTMARGIN,MARGIN_X
	invoke	GetDlgItem,hWnd,IDC_EDIT
	mov	r8d,offset WndProc
	invoke	SetWindowLongPtr,eax,GWL_WNDPROC
	mov	g_pOrgWndProc,rax
	jmp	wmdefault
wmCLOSE:invoke	EndDialog,,0
wmBYE:	leave
	retn
DlgProc endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
local	pt:POINT
local	sz[6]:BYTE
local	lc:dword
local	rect:RECT
local	rgn:qword
local	old_rsi:qword

	mov	hWnd,rcx
	mov	uMsg,edx
	mov	old_rsi,rsi

	mov	[rsp+20h],r9;lParam
	mov	r9,r8;wParam
	mov	r8,rdx;uMsg
	mov	edx,ecx;hWnd
        invoke	CallWindowProc,g_pOrgWndProc
	cmp	uMsg,WM_PAINT
	jnz	wmBYE
wmPAINT:invoke	SendMessage,hWnd,EM_GETLINECOUNT,0,0
	mov	lc, eax
	or	eax, eax
	jz	wmBYE
	invoke	GetDC,hWnd
	mov	hDC,rax
	lea	edx,rect
	invoke	GetClientRect,hWnd
	invoke	CreateRectRgn,rect.left,rect.top,rect.right,rect.bottom
	mov	rgn,rax	;rgn
	invoke	SelectClipRgn,hDC,eax
	invoke	BitBlt,hDC,0,0,MARGIN_X,rect.bottom,hDC,0,0,PATCOPY
	invoke	SendMessage,hWnd,EM_GETFIRSTVISIBLELINE,0,0
	mov	esi,eax;lineNo
;.while esi <= lc
@@:	invoke	SendMessage,hWnd,EM_LINEINDEX,esi,0
	inc	eax;eax = -1?
	jz	break
	lea	r9d,[rax-1]
	lea	r8d,pt
	invoke	SendMessage,hWnd,EM_POSFROMCHAR
	mov	eax,pt.y
	cmp	eax,rect.bottom
	ja	break;.break .if eax > rect.bottom
	inc	esi;lineNo+
	lea	ecx,sz
	mov	edx,offset aLu  ; "%lu"
	invoke	wsprintf,,,esi
	lea	r9d,sz
	mov	r8d,pt.y
	invoke	TextOut,hDC,0,,,eax
	cmp	esi,lc
	jbe	@b;.endw
break:	invoke	DeleteObject,rgn
	invoke	SelectClipRgn,hDC,0
	invoke	ReleaseDC,hWnd,hDC
wmBYE:	mov	rsi,old_rsi
	leave
	retn
WndProc endp
.data
aLu		db '%lu',0
LibFileName	db 'msftedit.dll',0
g_pOrgWndProc	dq ?
hDC		dq ?
hIcon		dq ?
end